Rules

Rules changelog

import { ProductChangelog } from "~/components";

{/* */}

2024-09-20

Automatic DNS Validation for Cloudflare Rules

The Cloudflare dashboard now automatically validates DNS records and Cloudflare for SaaS custom hostnames for rules targeting specific hostnames or URLs. To prevent misconfigured rules and ensure smoother deployments, you will get proactive warnings for missing or misconfigured DNS records and custom hostnames.

2024-09-17

Compression Rules available to all plans with Zstandard support

Compression Rules now support Zstandard compression and are available in all Cloudflare plans. Users in the Free plan will gradually get access throughout 2024.

2024-09-13

Snippets now available in beta

Cloudflare Snippets have transitioned from alpha to beta.

2024-09-10

wildcard_replace() function now supported in URL rewrites

You can now use the wildcard_replace() function in rewrite expressions of URL rewrites.

2024-09-05

New Rules Templates for one-click rule creation

The new Rules > Templates page in the Cloudflare dashboard allows you to create common rules with a single click, featuring dozens of pre-built templates. You can also access these templates directly from each product's rule builder. Also, explore the Examples gallery in the developer docs for real-world use cases and inspiration.

2024-08-22

Simplified UI for Single Redirects with wildcard support

The simplified UI for Single Redirects is now available to all users, making URL redirects easier and more intuitive. This update builds on the recent wildcard support in Ruleset Engine products. Access the new UI under Rules > Redirect Rules. Learn more about wildcard support and our open-source Rust crate in the blog post.

2024-08-20

Cloud Connector now available to all customers

Cloud Connector (beta) is now available to all customers. For setup details, refer to the documentation, explore examples, and check out the blog post.

2024-08-16

Cloud Connector now available to all free customers

Cloud Connector (beta) is now available to all free and a subset of paid customers. This rollout will be gradually extended to all Cloudflare users, simplifying multi-cloud management and enhancing integration with Cloudflare's Connectivity Cloud. For more information, refer to the blog post.

2024-08-12

Cloudflare Snippets limits have been upgraded

Cloudflare Snippets (alpha) now allow multiple subrequests depending on your plan. For more information, refer to the Availability.

2024-07-31

Wildcard support added to Ruleset Engine products

Wildcards are now supported across our Ruleset Engine-based products, including Single Redirects, Cache Rules, Transform Rules, WAF, Waiting Room, and more:

2024-07-01

Cloudflare Snippets now available to all paid customers

Cloudflare Snippets (alpha) are now available to all paid customers.

2024-06-03

Cloudflare Snippets now available to all Enterprise customers

Cloudflare Snippets (alpha) are now available to all Enterprise customers. Customers in other paid plans will gradually get access throughout 2024.

2024-05-14

Page Rules migration

The Page Rules migration guide is now available for users interested in transitioning to modern Rules features instead of Page Rules. Explore the guide for detailed instructions on migrating your configurations.

2024-05-13

New Configuration Rules setting for Web Analytics (RUM)

You can now turn off Cloudflare Web Analytics, also known as Real User Monitoring (RUM), for specific requests using a configuration rule.

2024-04-29

New Configuration Rules setting for Cloudflare Fonts

You can now turn on or off Cloudflare Fonts for specific requests using a configuration rule.

2024-03-22

New TLS fields in rule expressions

Customers can now use new fields cf.tls_client_hello_length (the length of the client hello message sent in a TLS handshake), cf.tls_client_random (the value of the 32-byte random value provided by the client in a TLS handshake), and cf.tls_client_extensions_sha1 (the SHA-1 fingerprint of TLS client extensions) in various products built on Ruleset Engine.

2024-03-20

Origin Rules now allow port numbers in Host Header Override

Customers can now use arbitrary port numbers in Host Header Override in Origin Rules. Previously, only hostname was allowed as a value (for example, example.com). Now, you can set the value to hostname:port (for example, example.com:1234) as well.

Rules examples

import { ResourcesBySelector, GlossaryTooltip } from "~/components";

Explore the following examples for Rules.

:::note

We have a separate listing for Cache rules examples.

:::

<ResourcesBySelector directory="rules" types={["example"]} filterables={["products"]} />

Cloudflare Rules

import { CardGrid, Feature, LinkTitleCard, Plan, RelatedProduct, } from "~/components";

Cloudflare Rules allows you to control how Cloudflare handles traffic to your website. For example, redirecting visitors, rewriting URLs, overriding where requests are sent, or customizing Cloudflare settings for specific requests.

Rules features require that your domain (or subdomain) has its DNS records proxied through Cloudflare, meaning traffic passes through the Cloudflare network before reaching your origin server.


Features

Customize Cloudflare configuration settings for matching incoming requests. Customize the behavior of your website or application using short pieces of JavaScript code. Adjust the URI path, query string, and HTTP headers of requests and responses on the Cloudflare global network. Redirect visitors from a source URL to a target URL with a specific HTTP status code. Use Single Redirects or Bulk Redirects depending on your use case. Customize where the incoming traffic will go and with which parameters. Override request properties such as `Host` header, destination hostname, and destination port. Route matching incoming traffic from your website to a public cloud provider such as AWS, Google Cloud, and Azure. Customize the compression applied to responses from Cloudflare's global network to your website visitors, based on the file extension and content type. Trigger certain actions when a request matches a URL pattern.

<Feature header="URL normalization" href="/rules/normalization/" cta="Configure URL normalization"

Modify the URLs of incoming requests so that they conform to a consistent
formatting standard.

<Feature header="Custom Errors" href="/rules/custom-errors/" cta="Configure Custom Errors"

Define what custom content to serve for errors returned by an origin server or
by a Cloudflare product, including Workers.

Control incoming traffic by filtering requests to a zone. You can block or challenge incoming requests according to rules you define.

<RelatedProduct header="Rate limiting rules" href="/waf/rate-limiting-rules/" product="waf"

Define rate limits for requests matching an expression, and the action to
perform when those rate limits are reached.

<RelatedProduct header="Cache rules" href="/cache/how-to/cache-rules/" product="cache"

Customize the cache properties of your HTTP requests.
Cloudflare Workers provides a serverless execution environment that allows you to create new applications or augment existing ones without configuring or maintaining infrastructure.

More resources

<LinkTitleCard title="Plans" href="https://www.cloudflare.com/plans/#overview" icon="document"

Compare available Cloudflare plans

Configure a Cloud Connector rule via API

import { APIRequest } from "~/components";

You can configure Cloud Connector rules using the Cloudflare API.

Required permissions

The API token used in API requests to manage Cloud Connector rules must have at least the following permission:

:::note A token with this permission is only valid for the Cloud Connector endpoints described in this page. You cannot use it to interact with the http_cloud_connector phase via Rulesets API. :::

Endpoints

To obtain the complete endpoint, append the Cloud Connector endpoints listed below to the Cloudflare API base URL:

https://api.cloudflare.com/client/v4

The {zone_id} argument is the zone ID (a hexadecimal string). You can find this value in the Cloudflare dashboard.

The following table summarizes the available operations.

Operation Verb + Endpoint
List Cloud Connector rules GET /zones/{zone_id}/cloud_connector/rules
Create/update/delete Cloud Connector rules PUT /zones/{zone_id}/cloud_connector/rules

Example API calls

List of Cloud Connector rules

The following example returns a list of existing Cloud Connector rules:

{
	"result": [
		{
			"id": "<RULE_1_ID>",
			"provider": "aws_s3",
			"expression": "http.request.uri.path wildcard \"/images/*\"",
			"description": "Connect to S3 bucket containing images",
			"enabled": true,
			"parameters": {
				"host": "examplebucketwithimages.s3.north-eu.amazonaws.com"
			}
		}
	],
	"success": true,
	"errors": [],
	"messages": []
}

Create/update/delete Cloud Connector rules

:::caution To create a new rule and keep all existing rules, you must include them all in your request body. Omitting an existing rule in the request body will delete the corresponding Cloud Connector rule. :::

The following example request will replace all existing Cloud Connector rules with a single rule:

<APIRequest path="/zones/{zone_id}/cloud_connector/rules" method="PUT" json={[ { expression: 'http.request.uri.path wildcard "/images/*"', provider: "cloudflare_r2", description: "Connect to R2 bucket containing images", parameters: { host: "mybucketcustomdomain.example.com", }, }, ]} />

The required body parameters for each rule are: expression, provider, and parameters.host.

The provider value must be one of the following: cloudflare_r2, aws_s3, azure_storage, gcp_storage, and oci_storage.

Configure a Cloud Connector rule in the dashboard

import { Render, Steps, DashButton } from "~/components";

To configure a Cloud Connector rule in the dashboard:

  1. In the Cloudflare dashboard, go to the Cloud Connector page.

  2. Select your cloud provider (Cloudflare R2 or an external provider).

  3. If you selected Cloudflare R2 in the previous step, select your bucket and your custom domain, and select Next.
    If you selected a different storage provider, enter the bucket URL and select Next.

    :::caution The bucket URL must follow a specific format according to your provider. :::

  4. Enter a descriptive name for the rule in Cloud Connector name.

  5. Under If, select Custom filter expression and enter an expression to define the traffic that will be redirected to the bucket. For example:

    • To route all requests matching http*://example.com/images/* (HTTPS and HTTP requests) you could enter the following expression:
      http.request.full_uri wildcard "http*://example.com/images/*"
    • To route all requests matching http*://images.example.com/* (HTTPS and HTTP requests) you could enter the following expression:
      http.request.full_uri wildcard "http*://images.example.com/*"

    Alternatively, select All incoming requests to redirect all incoming traffic for your zone to the storage bucket you selected.

  6. To save and deploy your rule, select Deploy. If you are not ready to deploy the rule, select Save as Draft.

Configure Cloud Connector rules using Terraform

import { Render } from "~/components";

You can create Cloud Connector rules using the Terraform Cloudflare provider.

To get started with Terraform for Cloudflare configuration, refer to Get started.

Required permissions

The API token used by Terraform must have at least the following permission:

Example configuration

The following example Terraform configuration creates Cloud Connector rules for various supported providers to route traffic between them based on URI paths:

resource "cloudflare_cloud_connector_rules" "cloud_connector_rules" {
  zone_id = "<ZONE_ID>"

  rules {
    description = "Route /data to GCP bucket"
    enabled     = true
    expression  = "(http.request.uri.path wildcard \"*/data/*\")"
    provider    = "gcp_storage"
    parameters {
      host = "mystorage.storage.googleapis.com"
    }
  }

  rules {
    description = "Route /resources to AWS bucket"
    enabled     = true
    expression  = "(http.request.uri.path wildcard \"*/resources/*\")"
    provider    = "aws_s3"
    parameters {
      host = "mystorage.s3.ams.amazonaws.com"
    }
  }

  rules {
    description = "Route /files to Azure bucket"
    enabled     = true
    expression  = "(http.request.uri.path wildcard \"*/files/*\")"
    provider    = "azure_storage"
    parameters {
      host = "mystorage.blob.core.windows.net"
    }
  }

  rules {
    description = "Route /images to R2 bucket"
    enabled     = true
    expression  = "(http.request.uri.path wildcard \"*/images/*\")"
    provider    = "cloudflare_r2"
    parameters {
      host = "mybucketcustomdomain.example.com"
    }
  }
}

More resources

Refer to the Terraform Cloudflare provider documentation for more information on the cloudflare_cloud_connector_rules resource.

Cloud Connector

import { ProductAvailabilityText, Render } from "~/components";

Cloud Connector allows you to route matching incoming traffic from your website to a public cloud provider that you define: Cloudflare R2 object storage or an external provider such as AWS, Google Cloud, Microsoft Azure, and Oracle Cloud. With Cloud Connector, you can manage traffic to cloud-hosted content through the same Cloudflare dashboard you use for the rest of your website, without having to configure additional rules.

<Render file="rules-requirements" product="rules" params={{ sentenceIntro: "Cloud Connector requires" }} />

How it works

First, you configure a Cloud Connector rule that specifies:

Then, Cloudflare will create the necessary configurations so that the content is accessible for requests matching your Cloud Connector rule. Your object storage bucket must be publicly accessible for Cloud Connector to work.

Cloud Connector rules are evaluated last in the request evaluation workflow. When a Cloud Connector rule matches and other rules have modified the same settings (such as the Host header), the Cloud Connector rule takes precedence.

Applied configurations

Cloud Connector will perform the following configurations automatically, depending on the cloud provider:

:::note[Additional configurations you may need]

Cloud Connector will not apply any of the following configurations:

:::

Availability

Cloud Connector is available in beta to all customers. The maximum number of rules depends on your Cloudflare plan:

Free Pro Business Enterprise
Availability Yes Yes Yes Yes
Number of rules 10 25 50 300

Supported cloud providers in Cloud Connector

import { Render, Steps } from "~/components";

Cloud Connector currently supports the following cloud providers and services:

Cloudflare R2

The Cloudflare R2 bucket must be public and exposed using a custom domain. Buckets exposed using an r2.dev subdomain are not supported.

Additionally, the custom domain must be defined in the same zone where you are configuring the Cloud Connector rule.

Amazon Web Services - S3

The hostname of your S3 bucket URL must have one of the following formats (where * is a wildcard character):

Cloud Connector supports both subdomain and URI path-style URLs:

SSL connections to AWS S3 endpoints

The SSL setting applied to requests between Cloud Connector and AWS S3 depends on the type of S3 endpoint you use:

Get the bucket URL

  1. Go to the Amazon S3 console and select Buckets in the navigation pane.
  2. Select the bucket name.
  3. Go to the Properties tab.
  4. Select the Static Website Hosting card. The Endpoint field shows your bucket URL.

For more information, refer to the Amazon S3 documentation.

Google Cloud Platform - Cloud Storage

The hostname of your Cloud Storage bucket URL must be the following (where * is a wildcard character):

Cloud Connector supports both subdomain and URI path-style URLs:

Get the bucket URL

  1. Go to the Google Cloud console and select Buckets.

  2. Select the bucket name.

  3. For one of the files already in the bucket, select the link icon in the Public column to copy the file's public URL to the clipboard. The file URL will have the following format:

    https://storage.googleapis.com/<BUCKET_NAME>/<OBJECT_NAME>

    To obtain the subdomain bucket URL, refactor the file URL to <BUCKET_NAME>.storage.googleapis.com format.
    To obtain the URI path bucket URL, remove https:// and /<BUCKET_NAME>/<OBJECT_NAME> from the file URL.

If the files in your bucket are not publicly accessible, you must change the bucket permissions. For details, refer to the Google Cloud Storage documentation.

Microsoft Azure - Blob Storage

The hostname of your Blob Storage bucket URL must have one of the following formats:

For Azure Blog Storage, Cloud Connector supports only subdomain URLs like <BUCKET_NAME>.blob.core.windows.net. This means that your files will be accessible directly under the root of the bucket. For example, https://example.com/index.html will map to https://<BUCKET_NAME>.blob.core.windows.net/index.html.

Get the bucket URL

  1. Go to the Azure portal and select your storage account.
  2. In the menu pane, under Settings, select Endpoints.
  3. Get your bucket URL from the Blob service endpoint or the Static website endpoint.

If the blob container is not configured for public access, you must change the container settings. For details, refer to the Azure Storage documentation.

Oracle Cloud Infrastructure Object Storage

Cloud Connector supports Oracle Cloud Infrastructure (OCI) Object Storage through the Amazon S3 Compatibility API.

:::caution[Public buckets only] Cloud Connector does not authenticate requests to OCI. Your bucket must allow anonymous object reads. Private buckets and pre-authenticated request URLs are not supported. :::

Enter an OCI hostname without a protocol, port, or path. Cloud Connector accepts the following formats:

Addressing style Hostname format Request path
Path style (traditional) <NAMESPACE>.compat.objectstorage.<REGION>.oraclecloud.com /<BUCKET_NAME>/<OBJECT_NAME>
Path style (dedicated) <NAMESPACE>.compat.objectstorage.<REGION>.oci.customer-oci.com /<BUCKET_NAME>/<OBJECT_NAME>
Virtual-hosted style <BUCKET_NAME>.vhcompat.objectstorage.<REGION>.oci.customer-oci.com /<OBJECT_NAME>

For path-style endpoints, include the bucket name in the incoming request path. For example, https://example.com/<BUCKET_NAME>/index.html maps to the same path on the OCI endpoint.

For virtual-hosted endpoints, the bucket name is part of the hostname. An incoming request to https://example.com/index.html maps to /index.html on that bucket. OCI requires virtual-hosted bucket names to use a regional scope and a DNS-compatible name that is unique within the region.

For more information, refer to Object Storage Dedicated Endpoints, Amazon S3 Compatibility API Hosted Style Support in Object Storage, and Changing an Object Storage Bucket's Visibility.

Cloud Connector examples

import { ResourcesBySelector } from "~/components";

<ResourcesBySelector directory="rules/cloud-connector/examples/" types={["example"]} />

Route /images to an S3 Bucket using Terraform

import { Render } from "~/components";

The following example defines a single Cloud Connector rule for a zone using Terraform. The rule routes requests to /images on your domain to an AWS S3 bucket.

resource "cloudflare_cloud_connector_rules" "serve_images_in_aws" {
  zone_id = "<ZONE_ID>"
  rules {
    description = "Route images to AWS S3 bucket"
    enabled     = true
    expression  = "http.request.full_uri wildcard \"https://<YOUR_HOSTNAME>/images/*\""
    provider    = "aws_s3"
    parameters {
      host = "<BUCKET_NAME>.s3.amazonaws.com"
    }
  }
}

Route /images to an S3 Bucket

import { Steps, DashButton } from "~/components";

To route requests to /images on your domain to an AWS S3 bucket:

  1. In the Cloudflare dashboard, go to the Cloud Connector page.

  2. Select Amazon S3 as your cloud provider.

  3. Enter the bucket URL. You can structure the URL in two ways:

    • Subdomain-style URL: Set the hostname to <BUCKET_NAME>.s3.amazonaws.com. In this case, your files should be organized in the root of the bucket, meaning the URI path will map directly to the file. For example, https://<YOUR_HOSTNAME>/images/file.jpg will map to https://<BUCKET_NAME>.s3.amazonaws.com/images/file.jpg.
    • URI path-style URL: Set the hostname to s3.amazonaws.com. Here, your bucket must include a folder named images, and files should be placed inside this folder. The URI path will then include the bucket name, like https://<YOUR_HOSTNAME>/<BUCKET_NAME>/images/file.jpg mapping to https://s3.amazonaws.com/<BUCKET_NAME>/images/file.jpg.
  4. (Optional) Use URL Rewrite Rules to adjust the URL structure. For example, you can create a URL rewrite that changes /images to /<BUCKET_NAME>/images to match the URI path-style URL structure.

  5. (Optional) Use Cache Rules to adjust the caching behavior for objects returned from the bucket. For example, you can create a cache rule that caches every returned object matching the /images/* URI path for seven days:

    • If incoming requests match > Custom filter expression: (starts_with(http.request.uri.path, "/images/"))
    • Cache eligibility: Eligible for cache
      • Edge TTL > Ignore cache-control header and use this TTL: 7 days
  6. Select Next and enter a descriptive name like Route images to S3 in Cloud Connector name.

  7. Under If, select Custom filter expression and enter the following expression:
    http.request.full_uri wildcard "http*://<YOUR_HOSTNAME>/images/*"
    Replace <YOUR_HOSTNAME> with desired hostname.

  8. Select Deploy to activate the rule.

This setup will route all traffic matching http*://<YOUR_HOSTNAME>/images/* (HTTPS and HTTP requests) to your S3 bucket. Make sure to replace <YOUR_HOSTNAME> with your actual hostname and adjust the example paths according to your setup.

Send EU visitors to a Google Cloud Storage bucket

import { Steps, DashButton } from "~/components";

To route requests from visitors in the European Union to a Google Cloud Storage bucket:

  1. In the Cloudflare dashboard, go to the Cloud Connector page.

  2. Select Google Cloud Storage as your cloud provider.

  3. Enter the bucket URL. You can structure the URL in two ways:

    • Subdomain-style URL: For <BUCKET_NAME>.storage.googleapis.com, your files should be organized in the root of the bucket. For example, https://<YOUR_HOSTNAME>/index.html will map to https://<BUCKET_NAME>.storage.googleapis.com/index.html.
    • URI path-style URL: If you set the hostname to storage.googleapis.com, your bucket must include folders corresponding to the intended URI paths. For example, if you want https://<YOUR_HOSTNAME>/eu/index.html to map to a file in your bucket, the file should be placed at https://storage.googleapis.com/<BUCKET_NAME>/eu/index.html.
  4. (Optional) Use URL Rewrite Rules to adjust the URL structure. For example, you can create a URL rewrite that changes /eu to /<BUCKET_NAME> to match the URI path-style URL structure.

  5. (Optional) Use Cache Rules to adjust the caching behavior for objects returned from the bucket. For example, you can create a cache rule that caches every returned object matching the /eu URI path for seven days (defined through the Edge TTL setting).

  6. Select Next and enter a descriptive name like Route EU visitors to GCP in Cloud Connector name.

  7. Under If, select Custom filter expression and enter the following expression: (ip.src.is_in_european_union)
    This expression targets traffic from European Union users.

  8. Select Deploy to activate the rule.

This configuration will route traffic from EU visitors to your Google Cloud Storage bucket. Make sure to replace <YOUR_HOSTNAME> with your actual hostname and adjust the example paths according to your setup.

Serve /static-assets from Azure Blob Storage

import { Steps, DashButton } from "~/components";

To serve static assets from an Azure Blob Storage container:

  1. In the Cloudflare dashboard, go to the Cloud Connector page.

  2. Select Microsoft Azure as your cloud provider.

  3. Enter the bucket URL. Use the following URL structure:

    • Subdomain-style URL: Set the hostname to <BUCKET_NAME>.blob.core.windows.net. In this case, your bucket should include a folder named static-assets, and files should be placed inside this folder. For example, https://<YOUR_HOSTNAME>/static-assets/style.css will map to https://<BUCKET_NAME>.blob.core.windows.net/static-assets/style.css.
  4. (Optional) Use URL Rewrite Rules to adjust the URL structure. For example, you can create a URL rewrite that changes /static-assets to /my-pages-project/static-assets to match the file structure of your object storage bucket.

  5. (Optional) Use Cache Rules to adjust the caching behavior for objects returned from the bucket. For example, you can create a cache rule that caches every returned object matching the /static-assets URI path for seven days (defined through the Edge TTL setting).

  6. Click Next and enter a descriptive name like Serve static assets from Azure in Cloud Connector name.

  7. Under If, select Custom filter expression and enter the following expression: http.request.full_uri wildcard "http*://<YOUR_HOSTNAME>/static-assets/*"

  8. Select Deploy to activate the rule.

This setup ensures that all traffic matching http*://<YOUR_HOSTNAME>/static-assets/* (HTTPS and HTTP requests) is served from your Azure Blob Storage container. Make sure to replace <YOUR_HOSTNAME> with your actual hostname and adjust the example paths according to your setup.

Create a compression rule via API

import { Render } from "~/components";

Use the Rulesets API to create a compression rule via API.

Basic rule settings

When creating a compression rule via API, make sure you:

Procedure

<Render file="rules-creation-workflow" product="rules" params={{ ruleName: "a compression rule", phaseName: "http_response_compression", }} />

Examples

For example API requests, refer to the Examples gallery.

Create a compression rule in the dashboard

import { Render, Steps, DashButton } from "~/components";

  1. In the Cloudflare dashboard, go to the Rules Overview page.

  2. Select Create rule > Compression Rule.

  3. (Optional) Select one of the rule templates that address common use cases. Then, review and adjust the proposed rule configuration.

  4. Enter a descriptive name for the rule in Rule name.

  5. Under When incoming requests match, select if you wish to apply the rule to default content types (content types that Cloudflare compresses by default), or to requests that match a custom filter expression.

  6. (Optional) To define a custom expression, use the Expression Builder (specifying one or more values for Field, Operator, and Value) or manually enter an expression using the Expression Editor. For more information, refer to Edit expressions in the dashboard.

  7. Under Compression options, set the compression options.

  8. To save and deploy your rule, select Deploy. If you are not ready to deploy your rule, select Save as Draft.

Compression Rules

import { Render } from "~/components";

Use Compression Rules to customize the compression applied to responses from Cloudflare's global network to your website visitors, based on the file extension and content type. Compression Rules are powered by the Ruleset Engine.

Cloudflare compresses some responses by default, based on the content type. With Compression Rules, you can customize the default behavior, which includes defining preferred compression algorithms for particular file types.

When a compression rule matches and lists several compression algorithms (such as gzip and Brotli), Cloudflare selects the first algorithm from your list that the visitor's browser supports. Cloudflare determines browser support from the accept-encoding HTTP request header, which browsers send automatically to indicate which compression formats they can decompress. If multiple compression rules match the same request, the last matching rule takes precedence.

<Render file="rules-requirements" product="rules" params={{ sentenceIntro: "Compression Rules require" }} />

Get started

Alternatively, follow the instructions in the following pages to get started:


Availability

Compression Rules are available in all Cloudflare plans.

Free Pro Business Enterprise
Availability Yes Yes Yes Yes
Number of rules 10 25 50 300

Relevant fields

The following fields are commonly used in expressions of compression rules:

Field in Expression Builder Field name
Media Type http.response.content_type.media_type
File extension http.request.uri.path.extension
N/A raw.http.request.uri.path.extension

Important remarks

<Render file="troubleshoot-rules-with-trace" product="rules" params={{ rulesFeatureName: "Compression Rules" }} />

Compression Rules settings

import { Details, Badge } from "~/components";

Compression Rules support the configuration settings covered in the following sections.

Dashboard configuration settings

Enable Zstandard (Zstd) compression

Sets Zstandard as the preferred compression algorithm. If it is not supported, will automatically fall back to Brotli, Gzip, or uncompressed data.

Enable Brotli and Gzip compression

Enables Cloudflare's default compression setting. Brotli is the preferred compression algorithm. It will automatically fall back to Gzip or to uncompressed data.

Disable compression

Disables compression for matching requests. Also disables Cloudflare's default compression behavior.

Custom

Defines a custom order for compression algorithms.

Allowed values are the following:

If you specify only Gzip, Brotli, or Zstandard and no algorithm matches, the response will have no compression. To configure a fallback compression mechanism, add Auto to the list.

:::note The compression applied by the Default option takes into account any configured compression rules that match incoming requests. :::


API configuration settings

The configuration object supported by the compress_response action has the following format:

"action_parameters": {
  "algorithms": [
    { "name": "<VALUE1>" },
    { "name": "<VALUE2>" },
    // ...
  ]
}

The algorithms list must contain at least one item.

The supported algorithm values are:

If you include none, default, or auto in the list, it must be the last value in the list.

When you specify only the gzip, brotli, or zstd algorithms, if no algorithm matches then the response will have no compression. To configure a fallback compression mechanism, add auto to the list.

For API examples, refer to the Examples gallery.

Disable Brotli compression

import { Example, TabItem, Tabs, APIRequest, Render } from "~/components";

The following example rule will disable Brotli compression for all incoming requests of a given zone. The only available compression algorithm will be Gzip.

When incoming requests match

Then

If the client does not support Gzip compression, the response will be uncompressed.

The following example sets the rules of an existing entry point ruleset (with ID {ruleset_id}) for the http_response_compression phase to a single compression rule, using the Update a zone ruleset operation:

<APIRequest path="/zones/{zone_id}/rulesets/{ruleset_id}" method="PUT" json={{ rules: [ { ref: "always_use_gzip", expression: "true", action: "compress_response", action_parameters: { algorithms: [{ name: "gzip" }], }, }, ], }} />

Disable compression for AVIF images

import { Example, TabItem, Tabs, APIRequest, Render } from "~/components";

The following example rule will disable compression for AVIF images, based on either the content type or the file extension specified in the request.

When incoming requests match

Then

The following example sets the rules of an existing entry point ruleset (with ID {ruleset_id}) for the http_response_compression phase to a single compression rule, using the Update a zone ruleset operation:

<APIRequest path="/zones/{zone_id}/rulesets/{ruleset_id}" method="PUT" json={{ rules: [ { ref: "disable_compression_for_avif", expression: 'http.response.content_type.media_type eq "image/avif" or http.request.uri.path.extension eq "avif"', action: "compress_response", action_parameters: { algorithms: [{ name: "none" }], }, }, ], }} />

Enable Zstandard compression for default content types

import { Example, TabItem, Tabs, APIRequest, Render } from "~/components";

The following example rule will turn on Zstandard compression for response content types where Cloudflare applies compression by default. If the client does not support Zstandard compression, it will use Brotli or Gzip compression as a fallback.

When incoming requests match

Then

The following example sets the rules of an existing entry point ruleset (with ID {ruleset_id}) for the http_response_compression phase to a single compression rule, using the Update a zone ruleset operation:

<APIRequest path="/zones/{zone_id}/rulesets/{ruleset_id}" method="PUT" json={{ rules: [ { ref: "use_zstd_compression", expression: '(http.response.content_type.media_type in {"text/html" "text/richtext" "text/plain" "text/css" "text/x-script" "text/x-component" "text/x-java-source" "text/x-markdown" "application/javascript" "application/x-javascript" "text/javascript" "text/js" "image/x-icon" "image/vnd.microsoft.icon" "application/x-perl" "application/x-httpd-cgi" "text/xml" "application/xml" "application/rss+xml" "application/vnd.api+json" "application/x-protobuf" "application/json" "multipart/bag" "multipart/mixed" "application/xhtml+xml" "font/ttf" "font/otf" "font/x-woff" "image/svg+xml" "application/vnd.ms-fontobject" "application/ttf" "application/x-ttf" "application/otf" "application/x-otf" "application/truetype" "application/opentype" "application/x-opentype" "application/font-woff" "application/eot" "application/font" "application/font-sfnt" "application/wasm" "application/javascript-binast" "application/manifest+json" "application/ld+json" "application/graphql+json" "application/geo+json"})', action: "compress_response", action_parameters: { algorithms: [{ name: "zstd" }, { name: "brotli" }, { name: "gzip" }], }, }, ], }} />

Use Gzip compression for CSV files

import { Example, TabItem, Tabs, APIRequest, Render } from "~/components";

The following example rule will configure Gzip compression as the preferred compression method for CSV files. If the visitor does not support this algorithm, Cloudflare will try to compress the response using a different algorithm supported by the visitor.

When incoming requests match

Then

The following example sets the rules of an existing entry point ruleset (with ID {ruleset_id}) for the http_response_compression phase to a single compression rule, using the Update a zone ruleset operation:

<APIRequest path="/zones/{zone_id}/rulesets/{ruleset_id}" method="PUT" json={{ rules: [ { ref: "use_gzip_for_csv", expression: 'http.request.uri.path.extension eq "csv"', action: "compress_response", action_parameters: { algorithms: [{ name: "gzip" }, { name: "auto" }], }, }, ], }} />

Compression Rules examples

import { ResourcesBySelector } from "~/components";

<ResourcesBySelector directory="rules/compression-rules/examples/" types={["example"]} />

Use only Brotli compression for a specific path

import { Example, TabItem, Tabs, APIRequest, Render } from "~/components";

The following example rule will configure only Brotli compression for a specific URI path.

When incoming requests match

Then

Since the rule configuration does not include Auto at the end of the custom algorithms list, the response will be uncompressed if the web visitor does not support Brotli.

The following example sets the rules of an existing entry point ruleset (with ID {ruleset_id}) for the http_response_compression phase to a single compression rule, using the Update a zone ruleset operation:

<APIRequest path="/zones/{zone_id}/rulesets/{ruleset_id}" method="PUT" json={{ rules: [ { ref: "use_only_brotli_for_assets_tar", expression: 'http.request.uri.path eq "/download/assets.tar"', action: "compress_response", action_parameters: { algorithms: [{ name: "brotli" }], }, }, ], }} />

Create a configuration rule via API

import { Details, Render, APIRequest } from "~/components";

Use the Rulesets API to create configuration rules via API.

Basic rule settings

When creating a configuration rule via API, make sure you:

Procedure

<Render file="rules-creation-workflow" product="rules" params={{ ruleName: "a configuration rule", phaseName: "http_config_settings", }} />

Make sure your API token has the required permissions to perform the API operations.

Example requests

The following example sets the rules of an existing phase ruleset ({ruleset_id}) to a single configuration rule — enabling Email Obfuscation and Browser Integrity Check for the contacts page — using the Update a zone ruleset operation:

<APIRequest path="/zones/{zone_id}/rulesets/{ruleset_id}" method="PUT" json={{ rules: [ { ref: "enable_email_obfuscation_bic", expression: 'starts_with(http.request.uri.path, "/contact-us/")', description: "Obfuscates email addresses and enables BIC in contacts page", action: "set_config", action_parameters: { email_obfuscation: true, bic: true, }, }, ], }} />

The following example sets the rules of an existing phase ruleset ({ruleset_id}) to a single configuration rule — turning on Under Attack mode for the administration area — using the Update a zone ruleset operation:

<APIRequest path="/zones/{zone_id}/rulesets/{ruleset_id}" method="PUT" json={{ rules: [ { ref: "enable_under_attack_in_admin", expression: 'http.host eq "admin.example.com"', description: "Turn on Under Attack mode for admin area", action: "set_config", action_parameters: { security_level: "under_attack", }, }, ], }} />


Required API token permissions

The API token used in API requests to manage configuration rules must have at least the following permission:

Create a configuration rule in the dashboard

import { Render, Steps, DashButton } from "~/components";

  1. In the Cloudflare dashboard, go to the Rules Overview page.

  2. Select Create rule > Configuration Rule.

  3. (Optional) Select one of the rule templates that address common use cases. Then, review and adjust the proposed rule configuration.

  4. Enter a descriptive name for the rule in Rule name.

  5. Under When incoming requests match, select if you wish to apply the rule to all incoming requests or only to requests that match a custom filter expression.

  6. (Optional) To define a custom expression, use the Expression Builder (specifying one or more values for Field, Operator, and Value) or manually enter an expression using the Expression Editor. For more information, refer to Edit expressions in the dashboard.

  7. Under Then the settings are, add the configuration settings you wish to change for requests matching the rule expression.

  8. To save and deploy your rule, select Deploy. If you are not ready to deploy your rule, select Save as Draft.

Configuration Rules

import { Render } from "~/components";

Configuration Rules allow you to customize certain Cloudflare configuration settings for matching incoming requests. For example, you can turn off specific features for certain URL paths or change settings based on the visitor's country.

Each configuration rule includes an expression that defines which requests the rule applies to, based on properties like URL path, hostname, or request header. For more information on expressions, refer to Expressions and Edit expressions in the dashboard.

<Render file="rules-requirements" product="rules" params={{ sentenceIntro: "Configuration Rules require" }} />


Rules templates

Availability

The number of available configuration rules varies according to your Cloudflare plan:

Free Pro Business Enterprise
Availability Yes Yes Yes Yes
Number of rules 10 25 50 300

Execution order

<Render file="troubleshoot-rules-with-trace" product="rules" params={{ rulesFeatureName: "Configuration Rules" }} />

Response body inspection

import { Steps } from "~/components";

When no enabled feature needs response content, Cloudflare can send data to the client as it arrives. Some features inspect or change response content at the edge.

Inspection can hold part of a response at the edge. This may increase time to first byte (TTFB) or delay incremental delivery. The amount of data held depends on the feature and response.

Features that inspect response bodies

Cloudflare features primarily inspect responses with a Content-Type of text/html. Some features change the body, while others only read it.

The following features can change HTML response bodies when turned on and applicable:

Feature Body change
AI Labyrinth Adds invisible links for unauthorized AI crawlers
Always Online Adds a banner to archived pages
Automatic HTTPS Rewrites Rewrites eligible HTTP links to HTTPS
Cloudflare challenge features Injects challenge scripts or returns challenge content
Cloudflare Fonts and Automatic Platform Optimization Rewrites Google Fonts references
Email Address Obfuscation Obfuscates email addresses in page content
Markdown for Agents Converts HTML to Markdown for eligible requests
Replace insecure JavaScript libraries Rewrites supported insecure library URLs
Rocket Loader Changes script loading behavior
Web Analytics Injects the Real User Monitoring beacon

When Response Body Buffering is set to None, these features do not change the response body.

Security and AI features may also read HTML without changing it. Prefetch URLs reads URL manifests served as text/plain.

This list excludes explicit rules that inspect response content. Review each rule separately when troubleshooting.

Streaming considerations

Response body inspection most often affects progressive HTML and plain-text streams. It can affect other responses selected by explicit inspection rules. A client may receive data later or in larger groups than the origin sent it.

Set an accurate Content-Type at your origin. Do not serve streaming API responses as text/html or text/plain unless that media type is required.

The Cache-Control: no-transform response directive prevents body changes by supported features. It does not prevent read-only inspection. Refer to Cache-Control directives for other effects of this directive.

Isolate inspection issues

If a response stops streaming after you proxy it through Cloudflare:

  1. Verify that the origin sends data incrementally without Cloudflare.
  2. Check the origin response's Content-Type and Cache-Control headers.
  3. Review features and rules that apply to the response path.
  4. Create a path-specific Configuration Rule that sets Response Body Buffering to None.
  5. Test the response again through Cloudflare.

The None setting streams the body without inspection. It can prevent security, optimization, and analytics features from working on matching responses. Use the narrowest matching expression possible.

For setting values and API configuration, refer to Response Body Buffering.

Configuration Rules settings

import { Details, Render } from "~/components";

You can change the configuration settings described below in a configuration rule.

Automatic HTTPS Rewrites

Automatic HTTPS Rewrites prevents end users from seeing Mixed content errors by rewriting URLs from http to https for resources or links on your website that can be served with HTTPS.

Use this setting to turn on or off Automatic HTTPS Rewrites for matching requests.

API configuration property name: "automatic_https_rewrites" (boolean).

"action_parameters": {
  "automatic_https_rewrites": true
}

Browser Integrity Check

Browser Integrity Check blocks access to pages based on specific HTTP headers commonly abused by spammers.

Use this setting to turn on or off Browser Integrity Check for matching requests.

API configuration property name: "bic" (boolean).

"action_parameters": {
  "bic": true
}

Disable Real User Monitoring (RUM)

Cloudflare Web Analytics, also known as Real User Monitoring (RUM), is Cloudflare's free, privacy-first analytics for your website.

Use this setting to turn off Web Analytics for matching requests.

API configuration property name: "disable_rum" (boolean).

"action_parameters": {
  "disable_rum": true
}

Disable Zaraz

Cloudflare Zaraz gives you complete control over third-party tools and services for your website, and allows you to offload them to the Cloudflare global network.

Use this setting to turn off Zaraz for matching requests.

API configuration property name: "disable_zaraz" (boolean).

"action_parameters": {
  "disable_zaraz": true
}

Email Obfuscation

Email Obfuscation prevents spam by hiding email addresses from bots and harvesters while keeping them visible to human visitors to your site.

Use this setting to turn on or off Email Obfuscation for matching requests.

API configuration property name: "email_obfuscation" (boolean).

"action_parameters": {
  "email_obfuscation": false
}

Fonts

Cloudflare Fonts rewrites Google Fonts to be delivered from a website's own origin, eliminating the need to rely on third-party font providers.

Use this setting to turn on or off Cloudflare Fonts for matching requests.

API configuration property name: "fonts" (boolean).

"action_parameters": {
  "fonts": false
}

Use this setting to turn on or off Hotlink Protection for matching requests.

API configuration property name: "hotlink_protection" (boolean).

"action_parameters": {
    "hotlink_protection": false
}

I'm Under Attack

When enabled, Under Attack mode performs additional security checks to help mitigate layer 7 DDoS attacks. Validated users access your website and suspicious traffic is blocked.

Use this setting to turn on or off Under Attack mode for matching requests.

API configuration property name: "security_level" (string).

API values: "off", "essentially_off", "under_attack".

"action_parameters": {
  "security_level": "under_attack"
}

Markdown for Agents

Markdown for Agents automatically converts HTML to Markdown for requests that use content negotiation headers (Accept: text/markdown).

Use this setting to turn on or off Markdown for Agents for matching requests.

API configuration property name: "content_converter" (boolean).

"action_parameters": {
  "content_converter": true
}

Opportunistic Encryption

Opportunistic Encryption allows browsers to access HTTP URIs over an encrypted TLS channel.

Use this setting to turn on or off Opportunistic Encryption for matching requests.

API configuration property name: "opportunistic_encryption" (boolean).

"action_parameters": {
  "opportunistic_encryption": true
}

Polish

Cloudflare Polish is a one-click image optimization product that automatically optimizes images in your site.

Use this setting to configure Polish for matching requests:

Refer to Compression options for more information on these values.

API configuration property name: "polish" (string).

API values: "off", "lossless", "lossy", "webp".

"action_parameters": {
  "polish": "webp"
}

Request Body Buffering

Use the Request Body Buffering setting to configure the request body buffering mode for matching requests:

:::caution Setting request body buffering to None may break functionality that requires body inspection. In particular, this can impact the effectiveness of the Web Application Firewall (WAF) and other security features that rely on analyzing request bodies to detect and block threats. :::

API configuration property name: "request_body_buffering" (string).

API values: "standard", "full", "none".

"action_parameters": {
  "request_body_buffering": "full"
}

Response Body Buffering

Use the Response Body Buffering setting to configure the response body buffering mode for matching requests:

For features that inspect response content and troubleshooting guidance, refer to Response body inspection.

:::caution Setting response body buffering to None may break functionality that requires body inspection. In particular, this can impact the effectiveness of the Web Application Firewall (WAF) and other security features that rely on analyzing response bodies to detect and block threats. :::

API configuration property name: "response_body_buffering" (string).

API values: "standard", "none".

"action_parameters": {
  "response_body_buffering": "standard"
}

Rocket Loader

Rocket Loader prioritizes your website's content (such as text, images, and fonts) by deferring the loading of all your JavaScript code until after rendering.

Use this setting to turn on or off Rocket Loader for matching requests.

API configuration property name: "rocket_loader" (boolean).

"action_parameters": {
  "rocket_loader": true
}

SSL

SSL/TLS encryption modes control the scheme (http:// or https://) that Cloudflare uses to connect to your origin web server and how SSL certificates presented by your origin will be validated.

Use this setting to configure the SSL/TLS encryption mode for matching requests:

Refer to Available encryption modes for more information on these values.

API configuration property name: "ssl" (string).

API values: "off", "flexible", "full", "strict", "origin_pull".

"action_parameters": {
  "ssl": "flexible"
}

Define a single configuration rule using Terraform

import { Render } from "~/components";

The following example defines a single configuration rule for a zone using Terraform. The rule disables Email Obfuscation and Browser Integrity Check for API requests.

# Disable a couple of Cloudflare settings for API requests
resource "cloudflare_ruleset" "http_config_rules_example" {
  zone_id     = "<ZONE_ID>"
  name        = "Config rules ruleset"
  description = "Set configuration rules for incoming requests"
  kind        = "zone"
  phase       = "http_config_settings"

  rules {
    ref         = "disable_obfuscation_bic"
    description = "Disable email obfuscation and BIC for API requests"
    expression  = "(http.request.uri.path matches \"^/api/\")"
    action      = "set_config"
    action_parameters {
      email_obfuscation = false
      bic               = false
    }
  }
}

Configuration Rules examples

import { ResourcesBySelector } from "~/components";

<ResourcesBySelector directory="rules/configuration-rules/examples/" types={["example"]} />

Common API calls for Custom Errors

import { APIRequest } from "~/components";

The following sections provide examples of common API calls for managing custom error assets and Error Pages at the zone level.

To perform the same operations at the account level, use the corresponding account-level API endpoints.

Create a custom error asset

The following POST request creates a new custom error asset in a zone based on the provided URL:

curl "https://api.cloudflare.com/client/v4/zones/$ZONE_ID/custom_pages/assets" \
--header "Authorization: Bearer $CLOUDFLARE_API_TOKEN" \
--json '{
  "name": "500_error_template",
  "description": "Standard 5xx error template page",
  "url": "https://example.com/errors/500_template.html"
}'
{
	"result": {
		"name": "500_error_template",
		"description": "Standard 5xx error template page",
		"url": "https://example.com/errors/500_template.html",
		"last_updated": "2025-02-10T11:36:07.810215Z",
		"size_bytes": 2048
	},
	"success": true
}

To create an asset at the account level, use the account-level endpoint:

https://api.cloudflare.com/client/v4/accounts/$ACCOUNT_ID/custom_pages/assets

List custom error assets

The following GET request retrieves a list of custom error assets configured in the zone:

curl "https://api.cloudflare.com/client/v4/zones/$ZONE_ID/custom_pages/assets" \
--header "Authorization: Bearer $CLOUDFLARE_API_TOKEN"
{
	"result": [
		{
			"name": "500_error_template",
			"description": "Standard 5xx error template page",
			"url": "https://example.com/errors/500_template.html",
			"last_updated": "2025-02-10T11:36:07.810215Z",
			"size_bytes": 2048
		}
		// ...
	],
	"success": true,
	"errors": [],
	"messages": [],
	"result_info": {
		"count": 2,
		"page": 1,
		"per_page": 20,
		"total_count": 2,
		"total_pages": 1
	}
}

To retrieve a list of assets at the account level, use the account-level endpoint:

https://api.cloudflare.com/client/v4/accounts/$ZONE_ID/custom_pages/assets

Update a custom error asset

The following PUT request updates the URL of an existing custom error asset at the zone level named 500_error_template:

curl --request PUT \
"https://api.cloudflare.com/client/v4/zones/$ZONE_ID/custom_pages/assets/500_error_template" \
--header "Authorization: Bearer $CLOUDFLARE_API_TOKEN" \
--json '{
  "description": "Standard 5xx error template page",
  "url": "https://example.com/errors/500_new_template.html"
}'
{
	"result": {
		"name": "500_error_template",
		"description": "Standard 5xx error template page",
		"url": "https://example.com/errors/500_new_template.html",
		"last_updated": "2025-02-10T13:13:07.810215Z",
		"size_bytes": 3145
	},
	"success": true
}

You can update the asset description and URL. You cannot update the asset name after creation.

If you provide the same URL when updating an asset, Cloudflare will fetch the URL again, along with its resources.

To update an asset at the account level, use the account-level endpoint:

https://api.cloudflare.com/client/v4/accounts/{account_id}/custom_pages/assets/{asset_name}

Get a custom error asset

The following GET request retrieves the details of an existing custom error asset at the zone level named 500_error_template:

curl "https://api.cloudflare.com/client/v4/zones/$ZONE_ID/custom_pages/assets/500_error_template" \
--header "Authorization: Bearer $CLOUDFLARE_API_TOKEN"
{
	"result": {
		"name": "500_error_template",
		"description": "Standard 5xx error template page",
		"url": "https://example.com/errors/500_new_template.html",
		"last_updated": "2025-02-10T13:13:07.810215Z",
		"size_bytes": 3145
	},
	"success": true
}

To retrieve an asset at the account level, use the account-level endpoint:

https://api.cloudflare.com/client/v4/accounts/$ACCOUNT_ID/custom_pages/assets/$ASSET_NAME

Delete a custom error asset

The following DELETE request deletes an existing custom error asset at the zone level named 500_error_template:

curl --request DELETE \
"https://api.cloudflare.com/client/v4/zones/$ZONE_ID/custom_pages/assets/500_error_template" \
--header "Authorization: Bearer $CLOUDFLARE_API_TOKEN"

If the request is successful, the response will have a 204 HTTP status code.

To delete an asset at the account level, use the account-level endpoint:

https://api.cloudflare.com/client/v4/accounts/$ACCOUNT_ID/custom_pages/assets/$ASSET_NAME

Get error page

This example obtains the current configuration for the Rate limiting block error page (with ID ratelimit_block).

<APIRequest path="/zones/{zone_id}/custom_pages/{identifier}" method="GET" parameters={{ identifier: "ratelimit_block", }} />

{
	"result": {
		"id": "ratelimit_block",
		"description": "Rate limit Block",
		"required_tokens": [],
		"preview_target": "block:rate-limit",
		"created_on": "2025-06-03T08:33:17.091587Z",
		"modified_on": "2025-06-03T08:33:17.091587Z",
		"url": null,
		"state": "default"
	},
	"success": true,
	"errors": [],
	"messages": []
}

The response indicates that the page is currently set to the Cloudflare default page ("state": "default").

For a list of error page identifiers, refer to Error page types.

Update error page

This example defines a custom error page for Rate limiting block errors (with ID ratelimit_block) based on the provided URL.

<APIRequest path="/zones/{zone_id}/custom_pages/{identifier}" method="PUT" parameters={{ identifier: "ratelimit_block", }} json={{ state: "customized", url: "https://example.com/rate_limiting_block_error_page.html", }} />

{
	"result": {
		"id": "ratelimit_block",
		"description": "Rate limit Block",
		"required_tokens": [],
		"preview_target": "block:rate-limit",
		"created_on": "2025-06-03T08:33:17.091587Z",
		"modified_on": "2025-06-03T08:35:32.639114Z",
		"url": "https://example.com/rate_limiting_block_error_page.html",
		"state": "customized"
	},
	"success": true,
	"errors": [],
	"messages": []
}

To set the error page back to the default page, use "state": "default" in the request body.

For a list of error page identifiers, refer to Error page types.

More resources

Create custom error rules

import { APIRequest, Render, Steps, DashButton } from "~/components";

In the dashboard

Create a custom error rule {/* create-a-custom-error-rule-dashboard */}

  1. In the Cloudflare dashboard, go to the Rules Overview page.

  2. Select Create rule > Custom Error Rule.

  3. Enter a descriptive name for the rule in Rule name.

  4. Under If incoming requests match, select one of the following options:

    • Custom filter expression: The rule will only apply to traffic matching a custom expression. Define the rule expression to configure which requests should be rewritten. Use either the Expression Builder or the Expression Editor to define the custom expression. For more information, refer to Edit expressions in the dashboard.

    • All incoming requests: The rule will apply to all responses with a 400 status code or above, except for block and challenge actions issued by Cloudflare’s security products.

  5. In Deliver a custom error response, select the response type (either Custom error asset or one of the available inline responses).

    If you select Custom error asset, select an existing custom error asset in Asset, or select Create new asset to create a new custom error asset.

    If you select JSON response, HTML response, Text response, or XML response, enter the custom error response you want to send to web site visitors in JSON response, HTML response, Text response, or XML response, respectively. The response can include error tokens that Cloudflare will replace with real values before sending the response to the visitor. The maximum response size is 10 KB.

  6. (Optional) In Response code, enter the HTTP status code of the response (an integer value between 400 and 999). If provided, this value will override the current response status code.

  7. (Optional) Under Place at, define where to place the rule in the rules list: first rule in the list, last rule in the list, or in a custom position (after a given rule).

  8. To save and deploy your rule, select Deploy. If you are not ready to deploy your rule, select Save as Draft.

Create a custom error asset {/* create-a-custom-error-asset-dashboard */}

  1. In the Create Custom Error Asset sidebar, enter a name for the asset in Asset name.
  2. (Optional) Enter a description for the asset in Description.
  3. In URL, enter the URL of the page you want to fetch and store in Cloudflare's global network. Cloudflare will fetch all the page resources and store a minified version of the page you can use in one or more custom error rules.
  4. Select Save.

To review existing custom error assets, go to Rules > Settings > Custom Error Assets tab.

Via API

To configure a custom error rule via API:

  1. (Optional) Create a custom error asset based on a URL you provide.
  2. Create a custom error rule in the http_custom_errors phase, using the Rulesets API.

Create a custom error asset {/* create-a-custom-error-asset-api */}

The following POST request creates new a custom error asset in a zone based on the provided URL:

curl "https://api.cloudflare.com/client/v4/zones/$ZONE_ID/custom_pages/assets" \
--header "Authorization: Bearer <API_TOKEN>" \
--json '{
  "name": "500_error_template",
  "description": "Standard 5xx error template page",
  "url": "https://example.com/errors/500_template.html"
}'
{
	"result": {
		"name": "500_error_template",
		"description": "Standard 5xx error template page",
		"url": "https://example.com/errors/500_template.html",
		"last_updated": "2025-02-10T11:36:07.810215Z",
		"size_bytes": 2048
	},
	"success": true
}

Create a custom error rule {/* create-a-custom-error-rule-api */}

When creating a custom error rule via API, make sure you:

The first rule in the http_custom_errors phase ruleset that matches will be applied. No other rules in the ruleset will be matched or applied. Additionally, custom error rules defined at the zone level will have priority over rules defined at the account level.

General procedure

Follow this workflow to create a custom error rule for a given zone via API:

  1. Use the List zone rulesets operation to check if there is already a ruleset for the http_custom_errors phase at the zone level.

  2. If the phase ruleset does not exist, create it using the Update a zone entry point ruleset operation, which allows you to create a ruleset if it does not exist and update all the rules in the ruleset. Create the ruleset in the http_custom_errors phase.

    If the phase ruleset already exists, use the Update a zone entry point ruleset operation to replace all the rules in the ruleset, or the Add a rule to a ruleset operation to add a rule to the existing rules in the ruleset.

To create a custom error rule at the account level, use the corresponding account-level API endpoints.

Example

This example configures a custom error rule returning a previously created custom error asset named 500_error_template for responses with a 500 HTTP status code.

<APIRequest path="/zones/{zone_id}/rulesets/phases/{ruleset_phase}/entrypoint" method="PUT" parameters={{ ruleset_phase: "http_custom_errors", }} json={{ rules: [ { ref: "serve_500_template", action: "serve_error", action_parameters: { asset_name: "500_error_template", content_type: "text/html", }, expression: "http.response.code eq 500", enabled: true, }, ], }} />

This PUT request, corresponding to the Update a zone entry point ruleset operation, replaces any existing rules in the http_custom_errors phase entry point ruleset.

Required API token permissions

The API token used in API requests to manage Custom Error Rules and Custom Error Assets must have at least the following permission:

Edit Error Pages

import { Render, Details, DashButton, Steps, Tabs, TabItem, } from "~/components";

You can define custom Error Pages for the following errors and challenges:

For more information on the different types of Error Pages, refer to Error page types.

To return custom error responses for requests that match specific conditions, use Custom Error Rules instead.

1. Design your custom error page

Before defining a custom error page in your Cloudflare account, you will need to design and code that page. It can be hosted on your own web server or using a Cloudflare product like Snippets.

When designing your custom error page, you can include page-specific custom error tokens. Each custom error token provides diagnostic information that appears on the error page.

To display a custom page for each error, create a separate page per error. For example, to create a custom error page for both IP/Country Block and WAF block, you must design and publish two separate pages.

:::note[Notes]

:::

You can use the following template to start building your error page:

<html>
	<head></head>
	<body>
		::[REPLACE WITH CUSTOM ERROR TOKEN NAME]::
	</body>
</html>

The following HTML code is an example error page for 5XX errors without styling:

<!doctype html>
<html>
	<head>
		<meta charset="utf-8" />
		<title>5XX Level Errors page</title>
	</head>
	<body>
		<h1>5XX Level Errors</h1>
		<h2>::CLOUDFLARE_ERROR_500S_BOX::</h2>
	</body>
</html>

2. Update an error page in the dashboard

You can define an error page at the zone level or for your entire account. Zone-level error pages have priority over account-level error pages.

To edit a zone-level custom error page:

  1. In the Cloudflare dashboard, go to the Error Pages page.

  2. Identify your desired custom error page type.

  3. (Optional) To preview the current error page (default or custom), select the link in the Show column.

  4. To edit the error page, select the three dots > Edit next to the page type you previously identified.

  5. To use Cloudflare's default page, select Cloudflare default page. To provide a custom error page, select Custom page and enter the URL of the custom error page you created.

  6. Select Confirm.

To update an account-level custom error page:

  1. In the Cloudflare dashboard, go to the Settings page.

  2. Go to Error Pages and identify your desired custom error page type.

  3. (Optional) To preview the current error page (default or custom), select the link in the Show column.

  4. To edit the error page, select the three dots > Edit next to the page type you previously identified.

  5. To use Cloudflare's default page, select Cloudflare default page. To provide a custom error page, select Custom page and enter the URL of the custom error page you created.

  6. Select Confirm.

Fetch custom error page again

After successfully setting the content of the custom error page in Error Pages, you can remove the page from your origin server.

If in the future, you need to update your custom error page, you must fetch the page again, even if the page URL remains unchanged. In this case, next to the page type you want to update, select the three dots > Fetch custom page again.

Example custom error rules

import { Tabs, TabItem, APIRequest, Render } from "~/components";

The provided examples use the following fields in their rule expressions:

Custom JSON response for all 5XX errors

This example configures a custom JSON error response for all 5XX errors (500-599) in a zone. The HTTP status code of the custom error response will be set to 530.

Custom error rule configuration:

<APIRequest path="/zones/{zone_id}/rulesets/phases/{ruleset_phase}/entrypoint" method="PUT" parameters={{ ruleset_phase: "http_custom_errors", }} json={{ rules: [ { ref: "json_response_for_5xx_errors", action: "serve_error", action_parameters: { content: '{"message": "A server error occurred."}', content_type: "application/json", status_code: 530, }, expression: "http.response.code ge 500 and http.response.code lt 600", enabled: true, }, ], }} />

This PUT request, corresponding to the Update a zone entry point ruleset operation, replaces any existing rules in the http_custom_errors phase entry point ruleset.

Custom HTML response with updated status code

This example configures a custom HTML error response for responses with a 500 HTTP status code, and redefines the response status code to 503.

Custom error rule configuration:

<APIRequest path="/zones/{zone_id}/rulesets/phases/{ruleset_phase}/entrypoint" method="PUT" parameters={{ ruleset_phase: "http_custom_errors", }} json={{ rules: [ { ref: "html_response_500_to_503", action: "serve_error", action_parameters: { content: '

Application temporarily unavailable

Please try again later.

', content_type: "text/html", status_code: 503, }, expression: "http.response.code eq 500", enabled: true, }, ], }} />

This PUT request, corresponding to the Update a zone entry point ruleset operation, replaces any existing rules in the http_custom_errors phase entry point ruleset.

Custom HTML response for Cloudflare 1020 errors

This example configures a custom HTML error response for Cloudflare error 1020 (Access Denied).

Custom error rule configuration:

<APIRequest path="/zones/{zone_id}/rulesets/phases/{ruleset_phase}/entrypoint" method="PUT" parameters={{ ruleset_phase: "http_custom_errors", }} json={{ rules: [ { ref: "html_response_cf_1020", action: "serve_error", action_parameters: { content: '

You do not have access to this page

Contact us if you think this is an error.

', content_type: "text/html", }, expression: "cf.response.1xxx_code eq 1020", enabled: true, }, ], }} />

This PUT request, corresponding to the Update a zone entry point ruleset operation, replaces any existing rules in the http_custom_errors phase entry point ruleset.

Custom error asset created from a URL

This example configures a custom error rule returning a previously created custom error asset named 500_error_template for responses with a 500 HTTP status code.

Custom error rule configuration:

<APIRequest path="/zones/{zone_id}/rulesets/phases/{ruleset_phase}/entrypoint" method="PUT" parameters={{ ruleset_phase: "http_custom_errors", }} json={{ rules: [ { ref: "serve_error_500_asset", action: "serve_error", action_parameters: { asset_name: "500_error_template", content_type: "text/html", }, expression: "http.response.code eq 500", enabled: true, }, ], }} />

This PUT request, corresponding to the Update a zone entry point ruleset operation, replaces any existing rules in the http_custom_errors phase entry point ruleset.

Custom Errors

import { Render, Steps } from "~/components";

Use Custom Errors to replace default Cloudflare error pages with your own custom content. Custom error content is shown to visitors when an HTTP error occurs, whether the error comes from your origin server, a Cloudflare product (including Cloudflare Workers), or a security challenge.

You can configure custom error content using the following methods:

Custom Errors require that you proxy the DNS records of your domain (or subdomain) through Cloudflare.

How it works

Cloudflare has a set of default pages for presenting errors and challenges to your website visitors. You can customize those pages using Error Pages and Custom Error Rules.

When an error of a specific type occurs, Cloudflare does the following:

  1. Search for a configured Error Page at the account level for the specific error.
  2. Search for a configured Error Page at the zone level for the specific error (it will have priority over the account-level Error Page, if any).
  3. Search for a matching custom error rule at the account level. The rule will have priority over 500 class and 1000 class Error Pages at the account or zone level.
  4. Search for a matching custom error rule at the zone level. The rule will have priority over 500 class and 1000 class Error Pages at the account or zone level and over custom error rules at the account level.
  5. If a security rule like a WAF custom rule or a rate limiting rule triggers a custom block response instead of a default Cloudflare WAF block page, the rule-specific block response will have priority over Error Pages or a matching custom error rule.
  6. If any of the previous configurations apply, serve the custom error content to the visitor. If not, serve the default error page for the specific error type in the format the client requested (JSON, Markdown, or HTML). For more details on structured error responses (JSON or Markdown), refer to Error responses.

:::note To customize a challenge page or the default Cloudflare WAF block page, use an Error Page. Custom Error Rules do not apply to security actions originating from Cloudflare products (such as the default WAF block page) — they only override error responses from your origin server or custom WAF responses. A custom WAF response configured directly in a WAF rule action takes precedence over both an Error Page and a custom error rule. :::

Availability

Custom Errors are available to all paid plans. The exact features depend on your Cloudflare plan.

Free Pro Business Enterprise
Availability No Yes Yes Yes
Number of rules 0 25 50 300
Number of assets 0 25 50 300
Error Pages No Yes Yes Yes
Origin Error Pages No No No Yes

Error Pages

Cloudflare uses a wide range of error codes to identify issues in handling request traffic. By default, these error pages mention Cloudflare; however, you can create custom error pages to provide a consistent brand experience for your users.

Error Pages do not apply to responses with an HTTP status code of 500, 501, 503, or 505. These exceptions help avoid issues with specific API endpoints and other web applications. You can still customize responses for these status codes using Custom Error Rules.

If you are on a Cloudflare paid plan, you can create custom error pages at the zone level or for your entire account. Zone-level error pages have priority over account-level error pages.

Additionally, Enterprise customers can customize 5XX error pages (except errors 520-527) at their origin by turning on Origin Error Pages in Error Pages in the dashboard.

You can design custom error pages to appear during a security challenge or when an error occurs. For more information on the different error page types, refer to Error page types.

:::note Cloudflare will return the default Cloudflare error page instead of your custom Error Pages if the incoming request does not contain an accept-encoding header. This does not apply to responses originating from Custom Error Rules. :::

Custom Error Rules

A custom error rule defines the conditions under which Cloudflare will serve custom error content to visitors in case of HTTP errors (status codes 400 and above), and the exact content that will be served to visitors.

When defining the content to serve, you provide either an inline response or the URL of an existing webpage. The URL can point to a webpage or to a different resource such as JSON content.

When you provide a URL, Cloudflare will gather any required images, CSS, and JavaScript code and save a minified version of the full page in the Cloudflare global network. This resource is called a custom error asset, which you can use in one or more custom error rules in the same scope of the asset (zone or account).

When a custom error rule is triggered, Cloudflare will replace the body with the response you previously defined and (optionally) the response HTTP status code sent to the visitor. Cloudflare will keep any existing HTTP response headers except for Content-Type and Content-Length.

Additionally, you can configure Response Header Transform Rules for error responses to add, change, or remove HTTP headers from the response.

Custom error rules have priority over Error Pages.

Custom Error Assets

A custom error asset corresponds to a web resource such as an HTML web page (including any referenced images, CSS, and JavaScript code) that Cloudflare fetches and saves based on a URL you provide, to be served to visitors as an error page.

Once the custom error asset is stored in Cloudflare's global network, the URL you initially provided no longer needs to be available. You can update an existing custom error asset by fetching it again. The metadata associated with each custom error asset includes the timestamp when the last fetch occurred, and this information is displayed in the dashboard.

You can use a custom error asset in one or more custom error rules in the same scope where you defined the asset (zone or account).

Size limits

When you provide a URL for a custom error asset, Cloudflare fetches the page and inlines all referenced resources into the HTML. Images and other binary resources (including those referenced from CSS via url(...)) are inlined as base64-encoded data URLs. CSS and JavaScript files are inlined as plain text inside <style> and <script> tags. The processed page must not exceed approximately 1.5 MB.

If your custom error asset exceeds this size, reduce the number or size of referenced resources. You can also host large resources externally, as long as they remain accessible from Cloudflare's network when the asset is fetched.

:::caution[Large assets increase bandwidth]

Because a custom error asset is served to every visitor that triggers the associated rule, a large asset can generate significant egress traffic. To reduce bandwidth and improve load times, keep the asset small by reducing the size or number of referenced images, fonts, and other binary resources. Cloudflare inlines referenced resources when fetching the asset, so external URLs are fetched and inlined as well.

:::

Troubleshoot Error Pages issues

If Cloudflare cannot load your site or you have blocked the United States (US) via IP Access rules or WAF custom rules, publishing and previewing a custom error page might not work.

A common error might look like the following: Error fetching page: Fetch failed, https://example.com/ipcountryblock.html returned 403 (Code: 1202).

Make sure that no WAF rule is blocking or challenging Custom Errors product when it is fetching the content of your custom error page.

Error pages for blocked requests

If you block countries or IP addresses with an IP Access rule, affected visitors will get a 1005 error and your IP/Country Block custom page.

If you block countries or IP addresses with a WAF custom rule and you do not configure a custom error rule or a WAF custom response for blocked requests, affected visitors will get your WAF Block page.

If you block requests due to a rate limiting rule and you do not configure a custom error rule or a WAF custom response for blocked requests, affected visitors will get your 429 Errors page displaying a Cloudflare 1015 error.

If you block countries or IP addresses with a firewall rule (now deprecated), affected visitors will get your 1000 Class Errors page.

1XXX errors

You cannot customize the following 1XXX errors via Error Pages:

Custom error page size

Your custom error page cannot be blank and the combined size of all page assets cannot exceed 1.5 MB (1,500,000 characters). To avoid exceeding the custom error page limit, preview your page to check its size before publishing.

General troubleshooting advice

If you encounter errors while attempting to preview or publish your custom error page, use an HTML validator to ensure that your code resolves properly.

More resources

Error page types

Page type Description API identifier
WAF block The page displayed when visitors are blocked by a Web Application Firewall rule. This page returns a 403 status code. waf_block
IP/Country block The page displayed when a request originates from a blocked IP address or country. This page returns a 403 status code. ip_block
IP/Country challenge Presents a challenge to visitors from specified IP addresses or countries. This page returns a 403 status code. For more information, refer to IP Access rules. country_challenge
500 class errors 500 class error pages are displayed when a web server is unable to process a request. For more information, refer to Cloudflare 5xx errors. 500_errors
1000 class errors 1000 class error pages are displayed when a domain’s configuration, security settings, or origin setup prevents Cloudflare from completing a request. For more information, refer to Cloudflare 1xxx errors. 1000_errors
Managed challenge / I'm Under Attack Mode Presents different types of challenges to a visitor depending on the nature of their request and your security settings. This page returns a 403 status code. For more information, refer to Under Attack mode. managed_challenge
Rate limiting block Displayed to visitors when they have been blocked by a rate limiting rule. This page returns a 429 status code. ratelimit_block

Error tokens

Each custom error token provides diagnostic information or specific functionality that appears on the error page. Certain error pages require a page-specific custom error token.

To display a custom page for each error, create a separate page per error. For example, to create an error page for both IP/Country Block and Interactive Challenge, you must design and publish two separate pages.

The following custom error tokens are required by their respective error pages:

Token Required for
::CAPTCHA_BOX:: Interactive Challenge
Country Challenge (Managed Challenge)
Managed Challenge / I'm Under Attack Mode (Interstitial Page)
::IM_UNDER_ATTACK_BOX:: Non-Interactive Challenge
::CLOUDFLARE_ERROR_500S_BOX:: 5XX Errors
::CLOUDFLARE_ERROR_1000S_BOX:: 1XXX Errors

Each custom error token has a default look and feel. However, you can use CSS to stylize each custom error tag using each tag's class ID. All the external resources like images, CSS, and scripts will be inlined during the process. As such, all external resources need to be available (that is, they must return 200 OK) otherwise an error will be thrown.

For Custom Error Assets, inline responses, and Error Pages

A custom error asset, inline response, or error page may also include the following error tokens, which will be replaced with their real values before sending the response to the visitor:

Token Description
::CLIENT_IP:: The visitor's IP address.
::RAY_ID:: A unique identifier given to every request that goes through Cloudflare.
::GEO:: The country or region associated with the visitor's IP address.

Reference

import { DirectoryListing } from "~/components";

This section contains reference information for Custom Errors.

Custom Errors parameters

import { Type, MetaInfo } from "~/components";

Custom error rules

Custom error rules define when a custom error gets triggered and the content that is served to visitors. Rule parameters are the following:

Response type

API name: N/A (handled via asset_name and content_type parameters)

The content type of the inline response to send to the website visitor (JSON, HTML, Text, or XML), or Custom error asset if sending the content of a custom error asset.

When using the API you must either set the asset_name or set both the content_type and content parameters. Refer to JSON response / HTML response / Text response / XML response.

Response code

API name: status_code

The HTTP status code of the response. If provided, this value will override the current response status code.

The status code must be between 400 and 999.

Asset

API name: asset_name

The name of the custom error asset you previously uploaded (in the dashboard, you can create an asset when creating the rule). The asset may include error tokens that will be replaced with real values before sending the error response to the visitor.

A custom error rule can only reference an asset defined in the same scope as the rule (that is, in the same zone or account).

In the dashboard, this parameter is only available when you select Custom error asset in Response type.

When using the API, you must provide either the asset_name or the content parameter.

JSON response / HTML response / Text response / XML response {/* response */}

API names: content and content_type

The response body to return. It can include error tokens that will be replaced with real values before sending the error response to the visitor.

You must provide either the asset_name or the content parameter.

The maximum content size is 10 KB.

When using the API you must also set the content_type parameter, which defines the content type of the returned response. The value must be one of the following:

:::caution

If you create an HTML error response, make sure the referrer meta tag is not present in the HTML code since it will disrupt Cloudflare challenges:

<meta name="referrer" (...) />

:::

Custom error assets

A custom error asset corresponds to a web resource such as an HTML web page (including any referenced images, CSS, and JavaScript code) that Cloudflare fetches and saves based on a URL you provide, to be served to visitors as an error page.

Custom error assets have the following parameters:

Asset name

API name: name

The name of the custom error asset. Example value: "500_error_template".

An asset name can contain the following characters:

- Uppercase and lowercase letters (`A-Z` and `a-z`)
- Numbers (`0-9`)
- The underscore (`_`) character

The maximum length is 200 characters.

Description

API name: description

A string describing the custom error asset. Example value: "Standard 5xx error template page".

Asset address

API name: url

The URL of the page you want Cloudflare to fetch and store, to be served later to visitors as error pages according to the configured custom error rules. Example value: "https://example.com/errors/500.html".

When you create or update an asset and provide a URL, Cloudflare collects any images, CSS, and JavaScript code used in the page, minifies the content, and saves it internally.

The content of the page at the specified URL may include error tokens that will be replaced with real values before sending the error response to the visitor.

When using the dashboard, you can later trigger another fetch to get the latest version of the page along with its resources, and store it internally.

When using the API, if you update an asset and provide the same URL, Cloudflare will fetch the URL again, along with its resources, and store it internally.

The maximum asset size is 1.5 MB.

URL normalization examples

The following table shows how different URL normalization settings affect request URLs before they pass to other Cloudflare features and to the origin server:

Incoming URL Normalization type Normalize incoming URLs Normalize URLs to origin URL at Cloudflare's network URL passed to origin server
www.example.com/hello (any) Off Off www.example.com/hello www.example.com/hello
www.example.com/hello (any) On Off www.example.com/hello www.example.com/hello
www.example.com/hello (any) On On www.example.com/hello www.example.com/hello
example.com/%68ello (any) Off Off example.com/%68ello example.com/%68ello
example.com/%68ello (any) On Off example.com/hello example.com/%68ello
example.com/%68ello (any) On On example.com/hello example.com/hello
example.com/%68ello//pa\th RFC-3986 Off Off example.com/%68ello//pa\th example.com/%68ello//pa\th
example.com/%68ello//pa\th RFC-3986 On Off example.com/hello//pa%5Cth example.com/%68ello//pa\th
example.com/%68ello//pa\th RFC-3986 On On example.com/hello//pa%5Cth example.com/hello//pa%5Cth
example.com/%68ello//pa\th Cloudflare Off Off example.com/%68ello//pa\th example.com/%68ello//pa\th
example.com/%68ello//pa\th Cloudflare On Off example.com/hello/pa/th example.com/%68ello//pa\th
example.com/%68ello//pa\th Cloudflare On On example.com/hello/pa/th example.com/hello/pa/th
example.com/hello//../path RFC-3986 On On example.com/hello/path example.com/hello/path
example.com/hello//../path Cloudflare On On example.com/path example.com/path
example.com/hello/\../path RFC-3986 On On example.com/hello/%5C../path example.com/hello/%5C../path
example.com/hello/\../path Cloudflare On On example.com/path example.com/path

How URL normalization works

import { Steps } from "~/components";

URL normalization modifies separators, encoded elements, and literal bytes in incoming URLs so that they conform to a consistent formatting standard.

For example, consider a WAF custom rule that blocks requests whose URLs match www.example.com/hello. The rule would not block a request containing an encoded element — www.example.com/%68ello. Normalizing incoming URLs on the Cloudflare global network helps simplify rules expressions containing URLs.

The two available types of URL normalization are:

The location where URL normalization will occur depends on the configured settings.

For examples of the different settings and their impact on request URLs, refer to the URL normalization examples.

RFC 3986 normalization

The URL normalization performed according to RFC 3986 is as follows:

Cloudflare normalization

When using the Cloudflare URL normalization, some extra normalization techniques will be applied to URLs of incoming requests, in the following order:

  1. Normalize back slashes (\) into forward slashes (/).
  2. Merge successive forward slashes (for example, // will be normalized to /).
  3. Perform RFC 3986 normalization of the resulting URL.

URL normalization

import { GlossaryTooltip, Render } from "~/components";

Cloudflare provides a URL normalization feature to modify the URLs of incoming requests so that they conform to a consistent formatting standard. This is important because the same resource can be requested using different URL formats (for example, /hello and /%68ello refer to the same path), and without normalization, security rules and other features might not match all variations of a URL.

When you enable URL normalization, all incoming URLs are normalized before they pass to subsequent global network features that accept a URL input, such as WAF custom rules, Workers, and Access. Rule expressions that filter traffic based on URLs will therefore trigger correctly, regardless of the format of the incoming URL. When URL normalization is disabled, Cloudflare forwards the URL to origin in its original form.

:::caution When traffic is proxied through Cloudflare, certain baseline URL normalization steps are always applied, even if you turn off URL normalization for your zone. For example, Cloudflare always converts two or more adjacent slashes into a single slash (such as //page to /page). You cannot disable these baseline normalizations. :::

URL normalization does not perform any redirects, and therefore it will not change the address displayed in the visitor's browser. The normalization operation, when enabled, occurs on the global network and affects Cloudflare features executed later and (optionally) the URL received at the origin server.

<Render file="rules-requirements" product="rules" params={{ sentenceIntro: "URL normalization requires" }} />


Availability

URL normalization is available in all Cloudflare plans.

Get started

Learn more about URL normalization and how to configure URL normalization in the Cloudflare dashboard.

Configure URL normalization in the dashboard

import { Steps, DashButton } from "~/components";

  1. In the Cloudflare dashboard, go to the Rules Settings page.

  2. Go to the URL Normalization tab.

  3. Configure the available URL normalization settings.

    Available URL normalization settings in the Cloudflare dashboard

URL normalization settings

The Cloudflare dashboard provides the following settings to manage URL normalization:

Normalization type

Default value: RFC-3986

Selects the type of normalization to perform:

Normalize incoming URLs

Default value: On

Configures the URLs of all incoming traffic to Cloudflare:

Normalize URLs to origin

Default value: Off

Configures URLs sent to the origin:

You can only view and enable this option when Normalize incoming URLs is enabled.

For examples of how these settings affect URL normalization, refer to the URL normalization examples.

Create an origin rule via API

import { Details, Render, APIRequest } from "~/components";

Use the Rulesets API to create origin rules via API.

Basic rule settings

When creating an origin rule via API, make sure you:

Procedure

<Render file="rules-creation-workflow" product="rules" params={{ ruleName: "an origin rule", phaseName: "http_request_origin" }} />

Make sure your API token has the required permissions to perform the API operations.

Example requests

The following example sets the rules of an existing phase ruleset ($RULESET_ID) to a single origin rule — overriding the SNI value of incoming requests addressed at admin.example.com — using the Update a zone ruleset operation.

<APIRequest path="/zones/{zone_id}/rulesets/{ruleset_id}" method="PUT" json={{ rules: [ { ref: "override_sni_for_admin", expression: 'http.host eq "admin.example.com"', description: "SNI Override for the admin area", action: "route", action_parameters: { sni: { value: "sni.example.com", }, }, }, ], }} />


Required API token permissions

The API token used in API requests to manage origin rules must have at least the following permission:

Create an origin rule in the dashboard

import { Render, Steps, DashButton } from "~/components";

  1. In the Cloudflare dashboard, go to the Rules Overview page.

  2. Select Create rule > Origin Rule.

  3. (Optional) Select one of the rule templates that address common use cases. Then, review and adjust the proposed rule configuration.

  4. Enter a descriptive name for the rule in Rule name.

  5. Under When incoming requests match, define the rule expression.

  6. Under Set origin parameters, define the origin rule settings you wish to change for requests matching the rule expression.

  7. To save and deploy your rule, select Deploy. If you are not ready to deploy your rule, select Save as Draft.

Origin Rules FAQ

import { Details, Example } from "~/components";

Below you will find answers to the most commonly asked questions regarding Origin Rules.

What happens if I use both an origin rule and a page rule to perform a Host header/DNS record override?

In this situation the origin rule parameters will override the page rule parameters.

Consider the following example scenarios:

Will Cloudflare automatically migrate my Page Rules with Host header and DNS record overrides to origin rules?

Yes. Refer to the Page Rules migration guide for any updates on the migration process.

What happens if more than one origin rule matches the current request?

If two or more origin rules match a request, the configuration of those rules is merged. While merging two configurations, the settings of later rules will override the settings defined in previous rules, updating or adding configuration properties. The final configuration applied by Cloudflare will be this merged version.

For example, if you configure the following two origin rules and both rules match, Cloudflare will use the destination port set by the first rule, and the DNS hostname override and Host header value set by the second rule.

Origin rule #1

Parameter Value
Set Host header example.com
Set destination port 8081

Origin rule #2

Parameter Value
Set Host header example.net
Set DNS hostname example.net

When using the API, you configure origin rule parameters in an action_parameters object.

{
	"rules": [
		{
			"expression": "http.request.uri.query contains \"/eu/\"",
			"description": "Origin rule #1",
			"action": "route",
			"action_parameters": {
				"host_header": "example.com",
				"origin": {
					"port": 8081
				}
			}
		},
		{
			"expression": "http.request.uri.query contains \"/eu/\"",
			"description": "Origin rule #2",
			"action": "route",
			"action_parameters": {
				"host_header": "example.net",
				"origin": {
					"host": "example.net"
				}
			}
		}
	]
}

The merged configuration to apply would be the following:

Parameter Value
Set Host header example.net
Set destination port 8081
Set DNS hostname example.net

If you also configured a destination port in rule #2, that value would override the 8081 destination port defined in rule #1.

Origin Rules settings

import { Example } from "~/components";

The following sections describe the available settings in Origin Rules.

Host header

Allows you to rewrite the HTTP Host header of incoming requests. The Host header tells the destination server which website or application the request is intended for.

A common use case for this functionality is when your content is hosted on a third-party server that only accepts Host headers with their own server names. In this situation, you must update the Host HTTP header in incoming requests from Host: example.com to Host: thirdpartyserver.example.net.

:::note[Notes]

:::

Server Name Indication (SNI)

Allows you to override the Server Name Indication (SNI) [^1] value of a request. For more information, refer to What is SNI (Server Name Indication)? in the Learning Center.

:::note[Notes]

:::

[^1]: SNI allows a server to host multiple TLS Certificates for multiple websites using a single IP address. SNI adds the website hostname in the TLS handshake to inform the server which website to present when using shared IPs.

DNS record

Allows you to override the resolved hostname of incoming requests, which controls which origin server Cloudflare sends the request to. This functionality is also known as resolve override.

A common use case is when you are serving an application from a specific path (for example, mydomain.com/app). In this case, the app may be hosted on a different server or by a third party. A DNS record override allows you to redirect requests to this endpoint to the server for that third-party application.

:::note

:::

The following example DNS records configure a resolve.example.com hostname pointing to an external hostname and IP address using a CNAME record and an A record, respectively:

Example CNAME record

Example A record

Destination port

Allows you to override the destination port of a request.

When you configure a destination port override, you can redirect incoming requests to a different port. For example, you could override the destination port for requests received for mydomain.com so that they are served by the application running on port 9000 (mydomain.com:9000).

The destination port must be between 1 and 65,535.

Origin Rules

import { Render } from "~/components";

Origin Rules allow you to change the origin server that Cloudflare sends a request to, or modify how the request reaches that server. This is useful when you need to route specific requests to a different backend, such as a third-party service or a server on a non-standard port. You can perform the following overrides:

Each origin rule includes a filter expression that defines which requests the overrides apply to (for example, matching on hostname, path, or other request properties).

<Render file="snippets-alternative" product="rules" params={{ suffix: "and customized modifications" }} />

<Render file="rules-requirements" product="rules" params={{ sentenceIntro: "Origin Rules require" }} />

Rules templates

Availability

Free Pro Business Enterprise
Availability Yes Yes Yes Yes
Number of rules 10 25 50 300
Override Host header No No No Yes
Override SNI No No No Yes
Override DNS records No No No Yes
Override destination port Yes Yes Yes Yes

Execution order

Important remarks

If you override the hostname with an origin rule (via Host header override or DNS record override) and add a header override to your load balancer configuration, the origin rule will take precedence over the load balancer configuration.

Like Page Rules, an origin rule performing a Host header override will update the SNI value of the original request to the same value of the Host header. To set an SNI value different from the Host header override, add an SNI override in the same origin rule or create a separate origin rule for this purpose.

<Render file="troubleshoot-rules-with-trace" product="rules" params={{ rulesFeatureName: "origin rules" }} />

Origin Rules API parameter reference

Create different overrides by including different action parameters in the action_parameters field:

Override type What to include
Host header override host_header parameter
SNI override sni object
DNS record override / Destination port override origin object

:::note The same origin rule can have different types of overrides. Refer to Configuring several overrides in the same rule for a syntax example. :::

Host header override parameters

The full syntax of the action_parameters field for overriding the HTTP Host header is the following:

"action_parameters": {
  "host_header": "<HOST_HEADER_VALUE>"
}

SNI override parameters

The full syntax of the action_parameters field for overriding the SNI value of incoming requests is the following:

"action_parameters": {
  "sni": {
    "value": "<SNI_VALUE>"
  }
}

DNS record override and destination port override parameters

The full syntax of the action_parameters field for overriding both the hostname and the destination port of incoming requests is the following:

"action_parameters": {
  "origin": {
    "host": "<HOSTNAME>",
    "port": <PORT>
  }
}

If you are only overriding the hostname or the port, omit the port or host parameter, respectively.

Configuring several overrides in the same rule

The same origin rule can have different types of overrides. For example, a single origin rule can perform an HTTP Host header override and a destination port override. The syntax of such a rule would be the following:

"action_parameters": {
[...]
